
package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.EmpresaCrediBancoConfigDAO;
import com.rjconsultores.ventaboletos.entidad.EmpresaCrediBancoConfig;

@Repository("empresaCrediBancoConfigDAO")
public class EmpresaCrediBancoConfigHibernateDAO extends GenericHibernateDAO<EmpresaCrediBancoConfig, Integer>
		implements EmpresaCrediBancoConfigDAO {

	@Autowired
	public EmpresaCrediBancoConfigHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<EmpresaCrediBancoConfig> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	public EmpresaCrediBancoConfig buscarChave(String chave, Integer empresaId) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		c.add(Restrictions.eq("chave", chave));
		c.add(Restrictions.eq("empresa.empresaId", empresaId));

		return (EmpresaCrediBancoConfig) c.uniqueResult();
	}

	public List<EmpresaCrediBancoConfig> buscarByEmpresa(Integer empresaId) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("empresa.empresaId", empresaId));

		return c.list();
	}
}
